package com.color.keyboard.black.activity;

import android.content.Intent;
import android.os.Bundle;
import android.view.LayoutInflater;
import android.view.View;
import android.widget.ImageView;

import androidx.annotation.NonNull;
import androidx.appcompat.app.AppCompatActivity;
import androidx.core.content.ContextCompat;
import androidx.fragment.app.Fragment;
import androidx.viewpager2.adapter.FragmentStateAdapter;
import androidx.viewpager2.widget.ViewPager2;

import com.bumptech.glide.Glide;
import com.color.keyboard.black.ColorApp;
import com.color.keyboard.black.R;
import com.color.keyboard.black.bean.ChildData;
import com.color.keyboard.black.bean.ClassData;
import com.color.keyboard.black.databinding.LayoutOneBinding;
import com.color.keyboard.black.manager.Common;
import com.color.keyboard.black.myfragment.FragmentLike;
import com.color.keyboard.black.myfragment.FragmentOne;
import com.google.android.material.tabs.TabLayout;

import java.util.ArrayList;
import java.util.Collections;
import java.util.List;
import java.util.Objects;

public class OneActivity extends AppCompatActivity {

    private LayoutOneBinding vb;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        vb = LayoutOneBinding.inflate(getLayoutInflater());
        Common.INSTANCE.initFullScreen(this, true);
        setContentView(vb.getRoot());
        loadBanner();
        init();

    }

    private void loadBanner() {
        List<ClassData> list = new ArrayList<>();
        list.addAll(ColorApp.list);
        Collections.shuffle(list);
        List<ChildData> keyboardList = list.get(0).getKeyboardList();
        Collections.shuffle(keyboardList);

        loadThumb(keyboardList.get(0), vb.im1);
        loadThumb(keyboardList.get(1), vb.im2);
        loadThumb(keyboardList.get(2), vb.im3);

        vb.viewFlipper.startFlipping();
    }

    private void loadThumb(ChildData data, ImageView imageView) {
        String thumbGif = data.getThumbGif();
        String thumb = data.getThumbUrl();
        if (!thumbGif.isEmpty()) {
            Common.INSTANCE.loadWepJif(this, thumbGif, imageView);
        } else {
            Glide.with(this).load(thumb)
                    .placeholder(R.drawable.im_placeholder)
                    .into(imageView);
        }
        imageView.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                Intent intent = new Intent(OneActivity.this, ApplyActivity.class);
                intent.putExtra(ApplyActivity.SOURCE_KEY, data);
                startActivity(intent);
            }
        });
    }

    private void init() {
        List<Fragment> listFragment = new ArrayList<>();
        listFragment.add(FragmentOne.newInstance());
        listFragment.add(FragmentLike.newInstance());

        for (int i = 0; i < listFragment.size(); i++) {
            TabLayout.Tab tab = vb.tabLayout.newTab();

            View inflate = LayoutInflater.from(this).inflate(R.layout.tab_view, null, false);
            ImageView icon = inflate.findViewById(R.id.im_icon);
//            TextView textView = inflate.findViewById(R.id.textView);
            if (i == 0) {
//                textView.setSelected(true);
//                textView.setText(getString(R.string.tv_home));
                icon.setImageDrawable(ContextCompat.getDrawable(this, R.drawable.selector_tab0));
            } else if (i == 1) {
//                textView.setSelected(false);
//                textView.setText(getString(R.string.tv_like));
                icon.setImageDrawable(ContextCompat.getDrawable(this, R.drawable.selector_tab1));
            }
            tab.setCustomView(inflate);
            vb.tabLayout.addTab(tab);
        }


        vb.viewpager.setUserInputEnabled(false);
        vb.viewpager.setAdapter(new FragmentStateAdapter(this) {
            @NonNull
            @Override
            public Fragment createFragment(int position) {
                return listFragment.get(position);
            }

            @Override
            public int getItemCount() {
                return listFragment.size();
            }
        });
        bing();
    }


    private void bing() {
        vb.tabLayout.addOnTabSelectedListener(new TabLayout.OnTabSelectedListener() {
            @Override
            public void onTabSelected(TabLayout.Tab tab) {
                ImageView icon = Objects.requireNonNull(tab.getCustomView()).findViewById(R.id.im_icon);
                icon.setSelected(true);
                vb.viewpager.setCurrentItem(tab.getPosition());
                int position = tab.getPosition();
                if(position == 0){
                    vb.topTitle.setText(getString(R.string.tv_skins));
                }else {
                    vb.topTitle.setText(getString(R.string.tv_like));
                }
            }

            @Override
            public void onTabUnselected(TabLayout.Tab tab) {
                ImageView icon = Objects.requireNonNull(tab.getCustomView()).findViewById(R.id.im_icon);
                icon.setSelected(false);
            }

            @Override
            public void onTabReselected(TabLayout.Tab tab) {

            }
        });
        vb.viewpager.registerOnPageChangeCallback(new ViewPager2.OnPageChangeCallback() {
            @Override
            public void onPageSelected(int position) {
                super.onPageSelected(position);
                Objects.requireNonNull(vb.tabLayout.getTabAt(position)).select();
            }
        });
    }
}